<?php


/*
  DFD Cart
  http://www.dragonfrugal.com/open.source/software/dfdcart
  
  DragonFrugal.com - Web Site Solutions

  Copyright (c) 2007 DragonFrugal.com

  Released under the GNU General Public License
*/

security_check($admin_key); // Verify this appears to be an administrator editing the database

// Import a plain-text, tab-delimited spreadsheet to add / update products...


// To compare what is already in the stored products when ready
stored_products_array();


if ( $_GET['phase'] || $_SESSION['phases_complete'] ) {

// Import the temporary data into the next phase
$name_of_file = $_SESSION['name_of_file'];
$row_offset = $_SESSION['row_offset'];
$imported_products = $_SESSION['imported_products'];
$import_error = $_SESSION['import_error'];
$error_note = $_SESSION['error_note'];
$to_be_unset = $_SESSION['to_be_unset'];
$spreadsheet_scan_results = $_SESSION['spreadsheet_scan_results'];
$spreadsheet_duplicate_count = $_SESSION['spreadsheet_duplicate_count'];

}


if ( $_POST['check_me'] ) {
///////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

$to_be_unset = array();

$name_of_file = $_FILES['import_file']['name'];

$import_file = $_FILES['import_file']['tmp_name'];
$fp = fopen($import_file,'r');

	if ( !$fp ) {
	echo 'ERROR: Unable to open file.';
	exit;
	}

	while ( !feof($fp) ) {
	$import_file_data = $import_file_data . fgets($fp, 4096); //use 4096 for very long lines
	$fp++;
	}
	fclose($fp);


// Increase the compatibility of finding the end of each product...
$import_file_data = eregi_replace("end_here", "END_HERE", $import_file_data); // All uppercase
$import_file_data = eregi_replace("\"END_HERE\"", "END_HERE", $import_file_data); // Remove quotes


// Now we can move on to parse out everything to import it...


// Split the products into array values
$imported_products = explode("	END_HERE", $import_file_data);

	if ( sizeof($imported_products) > 201 ) {
	?>
	<script>
	window.location.href = '?error=overload';
	</script>
	<?php
	}


	/*
	Further break down imported items into product attribute sub-arrays
	and scan all formatting / values before deciding whether or not import
	to the database and how for each item (adding or updating)
	*/
	$imported_row = $row_offset + 0;
	foreach ( $imported_products as $import_key => $import_value ) {
	$imported_products[$import_key] = eregi_replace("	END_HERE", "", $imported_products[$import_key]);
	
		//Scan for format errors...
		//Scan for tab-delimited format
		if ( sizeof($imported_products) < 1 ) {
		$import_error = "Your spreadsheet does not appear to contain <i>any</i> properly formatted data";
		}
		//Scan for extra tab spacing in description, price, etc that would screw up importing
		elseif ( eregi("(.*)	(.*)	(.*)", $imported_products[$import_key]) ) {
		$tab_message_format = $imported_products[$import_key];
		$tab_message_format = eregi_replace('""', '"', $tab_message_format);
		$error_note = "<div style='padding: 1px;'>NOTE: Correct or delete any blank space or corrupt data around the rows mentioned below, and make sure there are no blank spaces or data <i>below and to the sides</i> of <i>all</i> the spreadsheet rows and columns.</div>";
		$import_error = $import_error . "\n<div style='padding: 1px;'>Uncomplete or corrupt data around row $imported_row" . ": $tab_message_format</div>\n";
		}

		if ( !$import_error ) {

		// Split each product array into product attributes sub-arrays
		$product_attributes = explode('	', $import_value);


		// Description cleanup
		$product_attributes[0] = eregi_replace("\n", "", $product_attributes[0]);  // \N RETURN
		$product_attributes[0] = eregi_replace("\r", "", $product_attributes[0]);  // \R RETURN
		$product_attributes[0] = eregi_replace("	", "", $product_attributes[0]);  // TAB
			// Remove likely double quote text delimiter from alleged spreadsheet formatting
			if ( substr($product_attributes[0], 0, 1) == '"'
			&& substr($product_attributes[0], -1, 1) == '"' ) {
			$product_attributes[0] = substr_replace($product_attributes[0], "", 0, 1);
			$product_attributes[0] = substr_replace($product_attributes[0], "", -1, 1);
			}
		// Remove any remaining *dual* double quotes
		$product_attributes[0] = eregi_replace('""', '"', $product_attributes[0]);


		// Price cleanup
		$product_attributes[1] = eregi_replace("\n", "", $product_attributes[1]);  // \N RETURN
		$product_attributes[1] = eregi_replace("\r", "", $product_attributes[1]);  // \R RETURN
		$product_attributes[1] = eregi_replace("	", "", $product_attributes[1]);  // TAB
		$product_attributes[1] = eregi_replace(" ", "", $product_attributes[1]);  // SPACE
		$product_attributes[1] = eregi_replace("\\\$", "", $product_attributes[1]); // Dollar sign
		$product_attributes[1] = eregi_replace("[a-z]", "", $product_attributes[1]); // Letters
		$product_attributes[1] = eregi_replace('"', '', $product_attributes[1]); // Double quotes
		$product_attributes[1] = eregi_replace("'", "", $product_attributes[1]); // Single quotes
		/*
		Format XX.XX for price search compatibility, but with no commas above 3
		digits to the left of the decimal point, ***so order calculations aren't ruined***
		*/
		$product_attributes[1] = sprintf("%01.2f", $product_attributes[1]); 


		// Add to subarray after cleaning the product attributes
		$imported_products[$import_key] = array('product_description'=> $product_attributes[0], 'unit_price'=> $product_attributes[1], 'data_row'=> $imported_row + 1);
		}

	$imported_row = $imported_row + 1;
	}




	// If no import errors, scan for data entry errors next...
	if ( !$import_error ) {

		// Detect unvalid product data
		foreach ( $imported_products as $import_key => $import_value ) {


			if (  $imported_products[$import_key]['product_description']
			&& !eregi("[_a-z0-9-]",
			substr($imported_products[$import_key]['product_description'], 0, 1))  ) {
			
			$data_entry_error = $data_entry_error .
			"\n<div style='padding: 1px;'>" .
			"First character(s) of the description on row " .
			$imported_products[$import_key]['data_row'] .
			" are NOT alphanumeric: " .
			$imported_products[$import_key]['product_description'] .
			"&nbsp;&nbsp;&nbsp;&nbsp;" . $imported_products[$import_key]['unit_price'] .
			"</div>\n";
			
			$data_entry_error_count = $data_entry_error_count + 1;
			
			// Failsafe - remove products with errors from the import array
			unset($imported_products[$import_key]);
			
			$space_error = 1;
			
			}
			else {
			$space_error = NULL;
			}


			if ( !$space_error ) {
			
				if ( eregi("(.*)Product_Description(.*)",
				$imported_products[$import_key]['product_description'])
				|| !eregi("(.*)[a-z0-9-](.*)", $imported_products[$import_key]['product_description'])
				|| $imported_products[$import_key]['unit_price'] < 0.01 ) {
				
					/*
					Create an error message for the GUI if only partial data for
					a product was added...
					*/
					if ( !eregi("(.*)Product_Description(.*)",
					$imported_products[$import_key]['product_description']) ) {
					
						if (  !eregi("(.*)[a-z0-9-](.*)",
						$imported_products[$import_key]['product_description'])
						&& $imported_products[$import_key]['unit_price'] > 0
						|| eregi("(.*)[a-z0-9-](.*)",
						$imported_products[$import_key]['product_description']) 
						&& $imported_products[$import_key]['unit_price'] < 0.01  )  {
						
						$data_entry_error = $data_entry_error .
						"\n<div style='padding: 1px;'>" .
						"Missing product data on row " .
						$imported_products[$import_key]['data_row'] .
						": " .
						$imported_products[$import_key]['product_description'] .
						"&nbsp;&nbsp;&nbsp;&nbsp;" .
						$imported_products[$import_key]['unit_price'] .
						"</div>\n";
						
						$data_entry_error_count = $data_entry_error_count + 1;
						
						}
					
					}
				
				// Failsafe - remove products with errors from the import array
				unset($imported_products[$import_key]); 
				}
			
			}

		}

	}


///////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
}




/*
If there are no import errors *AND* no *current* data entry errors, then proceed to SCAN DEEPER and import VALID product data only...
*/
if ( !$import_error && !$data_entry_error ) {


	if ( $_POST['check_me'] || $_GET['phase'] == 2 ) {
	///////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////

		// Detect duplicates IN THE SPREADSHEET
		// Put every description into 1 string...
		foreach ( $imported_products as $import_key => $import_value ) {

		$duplicate_scan = $duplicate_scan . " DUP_SCAN " .
		strip_description_format($imported_products[$import_key]['product_description']);

		}
		$duplicate_scan = $duplicate_scan . " DUP_SCAN ";


		// Scan for duplicates...
		if ( !$spreadsheet_duplicate_count ) {
		$spreadsheet_duplicate_count = 0;
		}

		foreach ( $imported_products as $import_key => $import_value ) {

			if ( !$_GET['phase']
			&& eregi("(.*) DUP_SCAN " .
			strip_description_format($imported_products[$import_key]['product_description']) .
			" DUP_SCAN ".
			strip_description_format($imported_products[$import_key]['product_description']) .
			" DUP_SCAN (.*)", $duplicate_scan)
			|| $_GET['phase'] == 2
			&& $imported_products[$import_key]['product_description'] != "duplicate_value"
			&& substr_count($duplicate_scan, " DUP_SCAN " .
			strip_description_format($imported_products[$import_key]['product_description']) .
			" DUP_SCAN ") > 1 ) {

				if ( $_GET['phase'] == 2 ) {
				$scan_count = "Scan 2";
				}
				else {
				$scan_count = "Scan 1";
				}
		
		
			$spreadsheet_duplicate_count = $spreadsheet_duplicate_count + 1;

			// Spreadsheet duplicate results
			$spreadsheet_scan_results = $spreadsheet_scan_results .
			"<div style='padding: 1px; ".
			"font-weight: bold; color: red;'>".
			"$scan_count - Duplicate on row " .
			$imported_products[$import_key]['data_row'] .
			": ".
			$imported_products[$import_key]['product_description'].
			"&nbsp;&nbsp;&nbsp;".
			$imported_products[$import_key]['unit_price'].
			"</div>";
			
			/*
			Product is a duplicate, so mark for deletion instead of doing it now,
			so spreadsheet row logging remains intact
			*/
			// Flag the description for tracking
			$imported_products[$import_key]['product_description'] = "duplicate_value";
			$to_be_unset[] = $import_key;
			}

		}


	// Export needed data to sessions for the different phases of importing
	$_SESSION['name_of_file'] = $name_of_file;
	$_SESSION['row_offset'] = $row_offset;
	$_SESSION['imported_products'] = $imported_products;
	$_SESSION['import_error'] = $import_error;
	$_SESSION['error_note'] = $error_note;
	$_SESSION['to_be_unset'] = $to_be_unset;
	$_SESSION['spreadsheet_scan_results'] = $spreadsheet_scan_results;
	$_SESSION['spreadsheet_duplicate_count'] = $spreadsheet_duplicate_count;


		if ( !$_GET['phase'] ) {
		?>
		<script>
		window.location.href = '?phase=1';
		</script>
		<?php
		exit;
		}
		elseif ( $_GET['phase'] == 2 ) {
		?>
		<script>
		window.location.href = '?phase=3';
		</script>
		<?php
		exit;
		}

	///////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////
	}


	// Then import the UPDATE-ONLY products...
	foreach ( $imported_products as $import_key => $import_value ) {

		if ( $_SESSION['search_all_stored']
		&& $imported_products[$import_key]['product_description'] != "duplicate_value" ) {

			foreach ( $_SESSION['search_all_stored'] as $stored_key => $stored_value ) {

				if ( strip_description_format($imported_products[$import_key]['product_description']) == strip_description_format($_SESSION['search_all_stored'][$stored_key]['product_description'])  ) {

					if ( strip_description_format($imported_products[$import_key]['unit_price']) != strip_description_format($_SESSION['search_all_stored'][$stored_key]['unit_price'])  ) {

					database_connect();
					$database_request = "UPDATE product_list SET unit_price = '".$imported_products[$import_key]['unit_price']."', product_description = '".$imported_products[$import_key]['product_description']."' WHERE id = '".$_SESSION['search_all_stored'][$stored_key]['db_id']."'";
					
					mysql_query($database_request);
					mysql_close();
					
					// Product update results
					$import_update_results = $import_update_results .
					"<div style='padding: 1px; ".
					"font-weight: bold; color: #9b2891;'>".
					"Updated from row " .
					$imported_products[$import_key]['data_row'] .
					": ".
					$imported_products[$import_key]['product_description'].
					"&nbsp;&nbsp;&nbsp;".
					$imported_products[$import_key]['unit_price'].
					"&nbsp;&nbsp;Previous value: ". 
					$_SESSION['search_all_stored'][$stored_key]['product_description'].
					"&nbsp;&nbsp;&nbsp;".
					$_SESSION['search_all_stored'][$stored_key]['unit_price'].
					"&nbsp;&nbsp;(Id: ".
					$_SESSION['search_all_stored'][$stored_key]['db_id'].
					")</div>";
					
					$updated_imported_products = $updated_imported_products + 1;
					}

				/*
				Product is a duplicate, so mark for deletion instead of doing it now,
				so spreadsheet row logging remains intact
				*/
				$to_be_unset[] = $import_key;
				}

			}

		}

	}



	// Update-only products are done, so we remove them from the array of products to be added
	foreach ( $to_be_unset as $unset_key => $unset_value ) {
	unset($imported_products[$unset_value]);
	}


	if ( sizeof($imported_products) > 0 || !$_SESSION['search_all_stored'] ) {

		// Import all the NEW products too
		foreach ( $imported_products as $import_key => $import_value ) {

			if ( $imported_products[$import_key]['product_description'] != "duplicate_value" ) {
			
			database_connect();

			$database_request = "INSERT INTO product_list VALUES ('', '".
			$imported_products[$import_key]['unit_price']."', '".
			$imported_products[$import_key]['product_description']."')";

			mysql_query($database_request);

			mysql_close();
		
			$new_import_results = $new_import_results .
			"<div style='padding: 1px; font-weight: bold; color: #3f39ac;'>New product from row ".
			$imported_products[$import_key]['data_row'] .
			": " .
			$imported_products[$import_key]['product_description'] .
			"&nbsp;&nbsp;&nbsp;" . $imported_products[$import_key]['unit_price'] . "</div>";
			
			}
		
		}

	}


// Reorder the arrays just to keep it clean, AFTER ALL ROW COUNTING
$imported_products = array_values($imported_products);


	// Update confirmations...
	// New
	if ( sizeof($imported_products) < 1 ) {
	$new_imported_products = "0";
	}
	else {
	$new_imported_products = sizeof($imported_products);
	}
	// Updated
	if ( $updated_imported_products < 1 ) {
	$updated_imported_products = "0";
	}

	/*
	// Remove the duplicate products from the updated one's count
	if ( $updated_imported_products >= $spreadsheet_duplicate_count ) {
	$updated_imported_products = $updated_imported_products - $spreadsheet_duplicate_count;
	}
	*/

?>

<p>
<b><font style='color: #f44a1d;'>Imported file "<?php echo $name_of_file; ?>"...
<br />
<br />
Spreadsheet Importing Summary:<br />
<font style='color: #9b2891;'><?php echo $updated_imported_products; ?> updated product(s) were updated at the web site.</font><br />

<font style='color: #3f39ac;'><?php echo $new_imported_products; ?> new product(s) were added to the web site.</font><br />

<font style='color: red;'><?php echo $spreadsheet_duplicate_count; ?> spreadsheet duplicates were NOT imported to the web site.<?php if ( $spreadsheet_duplicate_count > 0 ) { ?>..<u>leave one of each duplicate listed below, delete the rest, and try again</u>.<?php } ?></font></font></b>
</p>
<b><font style='color: #f44a1d;'>***Detailed Results***</font></b>
<?php
	if ( !$spreadsheet_scan_results && !$import_update_results
	&& !$new_import_results ) {
?>
<div style='padding: 1px; font-weight: bold; color: #f44a1d;'>No detailed results to display</div>
<?php
}
?>

<div style='padding: 1px;'><?php echo $import_update_results; ?></div>

<div style='padding: 1px;'><?php echo $new_import_results; ?></div>

<div style='padding: 1px;'><?php echo $spreadsheet_scan_results; ?></div>

<?php
}

else {


	if ( $data_entry_error ) {
	$data_entry_error_message = "<div style='padding: 1px;'>$data_entry_error_count product(s) contain data entry errors (either no alphabetical ordering capability <i>&nbsp;or&nbsp;</i> missing product data): <br />\n" . $data_entry_error . "\n</div>\n";
	}

	if ( $import_error ) {
	$import_error_message = "<div style='padding: 1px;'>Spreadsheet formatting error(s) detected...<br />" . $import_error . "</div>"; // Spreadsheet formatting error
	}

?>

<p><b><font color='red'>Errors were detected in file "<?php echo $name_of_file; ?>"...</p>
<p><?php echo $error_note; ?></p>
<p>You can look in <span onclick='var answer_file = "importing.spreadsheets"; var answer_category = "general"; show_answer(answer_file, answer_category);' title="What's This?" style="color: red; text-decoration: underline; cursor: pointer;">Spreadsheet Import Help</span> for more details on correcting import issues.</font></b></p>
<p><b><font color='red'>
***Error Messages***<br />
<?php

echo $data_entry_error_message;  // Data entry error

echo $import_error_message;  // Spreadsheet formatting error

?>
</font></b></p>

<?php
}

if ( $_SESSION['phases_complete'] ) {

// Clear temp data used in the phases of importing products from spreadsheet
$_SESSION['phases_complete'] = FALSE;
$_SESSION['duplicate_delete'] = FALSE;

$_SESSION['name_of_file'] = FALSE;
$_SESSION['row_offset'] = FALSE;
$_SESSION['imported_products'] = FALSE;
$_SESSION['import_error'] = FALSE;
$_SESSION['error_note'] = FALSE;
$_SESSION['to_be_unset'] = FALSE;
$_SESSION['spreadsheet_scan_results'] = FALSE;
$_SESSION['spreadsheet_duplicate_count'] = FALSE;

}



// Debugging

//echo ereg_replace(" DUP_SCAN ", "\n<br />", $duplicate_scan);

/*
echo "<br clear='all'><br clear='all'>\"\$imported_products\" Array: <pre>";
print_r($imported_products);
echo "</pre>";


echo "<br clear='all'>Session \"search_all_stored\": <pre>";
print_r($_SESSION['search_all_stored']);
echo "</pre>";
*/


?>